﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections.Generic;

namespace TreeMapToolTips
{
    public class ViewModel: INotifyPropertyChanged
    {
        private ObservableCollection<NodeClass> _nodes;
        public ObservableCollection<NodeClass> Nodes
        {
            get { return _nodes; }
            set 
            {
                _nodes = value;
                NotifyPropertyChanged("Nodes");
            }
        }

        public ViewModel()
        {
            CreateNodes();
        }

        private void CreateNodes()
        {
            List<NodeClass> parents = new List<NodeClass>();

            NodeClass parentNode = new NodeClass() { Id = Guid.NewGuid(), Name = "Parent Node", Count = 65};
            NodeClass child1 = new NodeClass() { Id = Guid.NewGuid(), Name = "Child One", Count = 20};
            NodeClass grandchild1 = new NodeClass() { Id = Guid.NewGuid(), Name = "Grandchild One", Count = 10};
            NodeClass greatGC1 = new NodeClass() { Id = Guid.NewGuid(), Name = "GGC One", Count = 5};
            NodeClass greatGC2 = new NodeClass() { Id = Guid.NewGuid(), Name = "GGC Two", Count = 5};
            NodeClass grandchild2 = new NodeClass() { Id = Guid.NewGuid(), Name = "Grandchild Two", Count = 10 };
            NodeClass child2 = new NodeClass() { Id = Guid.NewGuid(), Name = "Child Two", Count = 15};
            NodeClass grandchild3 = new NodeClass() { Id = Guid.NewGuid(), Name = "Grandchild Three", Count = 15};
            NodeClass child3 = new NodeClass() { Id = Guid.NewGuid(), Name = "Child Three", Count = 20};

            child2.Children.Add(grandchild3);
            grandchild1.Children.Add(greatGC1);
            grandchild1.Children.Add(greatGC2);
            child1.Children.Add(grandchild1);
            child1.Children.Add(grandchild2);
            parentNode.Children.Add(child1);
            parentNode.Children.Add(child2);
            parentNode.Children.Add(child3);

            parents.Add(parentNode);
           
            Nodes = new ObservableCollection<NodeClass>(parents);
        }




        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string propName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
    }
}
